unit Unit2;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  Unit1;

type

  { TCalibrate_Form }

  TCalibrate_Form = class(TForm)
    Apply_Button: TButton;
    Capture_Low_Button: TButton;
    Capture_High_Button: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    m_Val_Label: TLabel;
    Low_Display_Point_Edit: TEdit;
    High_Display_Point_Edit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    b_Val_Label: TLabel;
    Range_Val_Label: TLabel;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Low_End_Color_Rectangle: TShape;
    High_End_Color_Rectangle: TShape;
    procedure Apply_ButtonClick(Sender: TObject);
    procedure Capture_High_ButtonClick(Sender: TObject);
    procedure Capture_Low_ButtonClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

var
  Calibrate_Form: TCalibrate_Form;

implementation

{$R *.lfm}

{ TCalibrate_Form }

procedure TCalibrate_Form.Capture_Low_ButtonClick(Sender: TObject);
begin
         Main_Form.Read_RxString(self);
         Main_Form.low_ADC_raw_point := Main_Form.raw_ADC;
end;

procedure TCalibrate_Form.FormActivate(Sender: TObject);
begin
     Calibrate_Form.Left := Main_Form.Left;
     Calibrate_Form.Top := Main_Form.Top + 300;
     m_Val_Label.Caption := FloatToStr(Main_Form.m);
     b_Val_Label.Caption := FloatToStr(Main_Form.b);
     Range_Val_Label.Caption := IntToStr(Main_Form.cal_range);
end;

procedure TCalibrate_Form.FormClose(Sender: TObject;
  var CloseAction: TCloseAction);
begin
         Main_Form.Enabled := True;
end;

procedure TCalibrate_Form.FormCreate(Sender: TObject);
begin
    {$IFDEF WINDOWS}
         Low_End_Color_Rectangle.Left := Low_End_Color_Rectangle.Left + 1;
         High_End_Color_Rectangle.Left := High_End_Color_Rectangle.Left + 1;
    {$ENDIF}
end;

procedure TCalibrate_Form.Capture_High_ButtonClick(Sender: TObject);
begin
         Main_Form.Read_RxString(self);
         Main_Form.high_ADC_raw_point := Main_Form.raw_ADC;
end;

procedure TCalibrate_Form.Apply_ButtonClick(Sender: TObject);

begin
         Main_Form.low_display_point :=  StrToFloat(Low_Display_Point_Edit.Text);
         Main_Form.high_display_point :=  StrToFloat(High_Display_Point_Edit.Text);
         Main_Form.m :=  (Main_Form.high_display_point - Main_Form.low_display_point) / (Main_Form.high_ADC_raw_point - Main_Form.low_ADC_raw_point);
         Main_Form.b := Main_Form.high_display_point - (Main_Form.m * Main_Form.high_ADC_raw_point);
         Main_Form.cal_range := Main_Form.range;
         Main_Form.Calibrated := True;
         Main_Form.Calibrated_label.Font.Color := $00929200;
         Calibrate_Form.Hide;
         Main_Form.Enabled := True;
end;

end.

