unit Unit3;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Spin,
  ComCtrls, ExtCtrls, LazSerial, Unit1;

type

  { TSave_Data_Form }

  TSave_Data_Form = class(TForm)
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    FileName_Edit: TEdit;
    File_Select_Button: TButton;
    Accept_Button: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Data_Transfer_LazSerial: TLazSerial;
    Label7: TLabel;
    OpenDialog: TOpenDialog;
    Save_Data_CheckBox: TCheckBox;
    Send_Data_CheckBox: TCheckBox;
    Saving_Time_SpinEdit: TSpinEdit;
    Data_Transfer_Serial_Port_Edit: TEdit;
    Send_Data_to_Clipboard_CheckBox: TCheckBox;
    procedure Accept_ButtonClick(Sender: TObject);
    procedure File_Select_ButtonClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure Send_Data_CheckBoxChange(Sender: TObject);
  private

  public

  end;

var
  Save_Data_Form: TSave_Data_Form;

implementation

{$R *.lfm}

{ TSave_Data_Form }

procedure TSave_Data_Form.File_Select_ButtonClick(Sender: TObject);
begin
       if OpenDialog.Execute then
       begin
         Main_Form.save_filename := OpenDialog.Filename;
         FileName_Edit.Text := ExtractFileName(Main_Form.save_filename);
       end;
end;

procedure TSave_Data_Form.FormActivate(Sender: TObject);
begin
  Save_Data_Form.Left := Main_Form.Left + 50;
  Save_Data_Form.Top := Main_Form.Top + 300;
end;

procedure TSave_Data_Form.FormClose(Sender: TObject;
  var CloseAction: TCloseAction);
begin
      Save_Data_Form.Accept_ButtonClick(Self);
end;

procedure TSave_Data_Form.FormCreate(Sender: TObject);
begin
    {$IFDEF WINDOWS}
            FileName_Edit.Top := FileName_Edit.Top + 8;
    {$ENDIF}
     FileName_Edit.Text := ExtractFileName(Main_Form.save_filename);
     Data_Transfer_Serial_Port_Edit.Text := Main_Form.Data_Transfer_Serial_Port;
end;

procedure TSave_Data_Form.Send_Data_CheckBoxChange(Sender: TObject);
begin
      if Send_Data_CheckBox.Checked = True then
      begin
           Data_Transfer_LazSerial.Device := Data_Transfer_Serial_Port_Edit.Text;
           try
           Data_Transfer_Serial_Port_Edit.Enabled := False;
           Data_Transfer_LazSerial.open;
           except
                 On E :Exception do
                 begin
                      ShowMessage('Error! Data Transfer Serial port is unavailable or not present. Verify port naming.');
                      Send_Data_CheckBox.Checked := False;
                      Data_Transfer_Serial_Port_Edit.Enabled := True;
                      exit;
                 end;
           end;
      end
      else begin
               Data_Transfer_LazSerial.close;
               Data_Transfer_Serial_Port_Edit.Enabled := True;
      end;
end;

procedure TSave_Data_Form.Accept_ButtonClick(Sender: TObject);
begin
      Main_Form.save_data_accepted := True;
      Save_Data_Form.Hide;
      Main_Form.Enabled := True;
      Application.Restore;
end;

end.

